import "mapping.wdl" as maptool
import "variant.wdl" as vartool

workflow WGSWDL {
	
	Array[Array[File]] sample_info
	Array[String] sample_name
	File Ref

	scatter (i in range(length(sample_info))) {
		call maptool.mkdir as mk_sap {
			input: dirName = sample_info[i][0]
		}
		call maptool.mkdir_module as mk_map {
			input: dirName1 = mk_sap.path, dirName2 = "mapping"
		}
		call maptool.mkdir_module as mk_var {
			input: dirName1 = mk_sap.path, dirName2 = "variant"
		}
		call maptool.mkdir_module as mk_cln {
			input: dirName1 = mk_sap.path, dirName2 = "cleandata"
		}
		call maptool.fastp as fastp {
			input: sample_info = sample_info[i], sample_name = sample_name[i], outdir = mk_cln.path
		}
		call maptool.bwa_mem as bwa {
			input: reado = fastp.reado, readt = fastp.readt, sample_name = sample_name[i], Ref_file = Ref, outdir = mk_map.path
		}
		call maptool.samtobam as stb {
			input: sam = bwa.sam
		}
		call maptool.sortbam as sort {
			input: bam = stb.outbam
		}
		call maptool.markdup as dup {	
			input: bam = sort.outbam
		}
		call maptool.bamindex as bamindex {
			input: bam = dup.outbam
		}
		call vartool.haplotypecaller as hc {
			input: bam = bamindex.outbam, sample_name = sample_name[i], Ref_file = Ref, outdir = mk_var.path
		}
	}
	Array[File] gvcf_list = hc.vcf
	call vartool.combinevcf as combine {
		input: gvcf_list = gvcf_list, Ref_file = Ref , outdir = "./"
	}
}
