task haplotypecaller {
	
	File bam
	String sample_name
	String Ref_file
	String outdir

	command {
		java -jar /gatk/gatk.jar HaplotypeCaller -R ${Ref_file} -I ${bam} -O ${outdir + "/" + sample_name + ".g.vcf"} -ERC GVCF
	}

	output {
		File vcf = "${outdir}/${sample_name}.g.vcf"
	}

	runtime{
		docker:"gatk4:latest"
		cpu:"4"
		memory:"30G"
	}
}

task combinevcf {
	
	Array[File] gvcf_list
	String Ref_file
	File outdir	
	command {
		java -jar /gatk/gatk.jar CombineGVCFs -V ${sep=' -V ' gvcf_list} -O result.vcf -R ${Ref_file}
		cp result.vcf ${outdir}
	}

	output { 
		File vcf = "result.vcf"
	}

	runtime{
		docker:"gatk4:latest"
		cpu:"4"
		memory:"30G"
	}
}
